Livrable/Gestionnaire_de_Projets/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();

Route::get('notif', function(){
});
Route::get('/user/notif/seen/{data}','HomeController@notifSeen')->name('user.notif.seen');
Route::get('/admin/register', 'HomeController@adminRegisterIndex')->name('admin.register.index');//->middleware('admin')
Route::post('/admin/register/save', 'HomeController@firstAdminStore')->name('admin.register.save');

Route::get('/register', 'UserController@registerIndex')->name('register.index');/*->middleware('can:create,App\User');*/
Route::get('/register/save', 'UserController@store')->name('register.save');

Route::get('/', 'HomeController@index')->name('home.index');

Route::resource('Projects','ProjectController');
Route::resource('Tasks','TaskController');

Route::get('/{id}/myProjects','ProjectController@ManagerProjets')->name('Project.ManagerProjets');

Route::match(['PUT', 'PATCH'],'/Tasks/{id}/save','TaskController@updateProgress')->name('Tasks.updateProgress');
//Route::match(['PUT', 'PATCH'], '/Tasks/{id}/add/{empid}',)->name('Tasks.addEmployee');
Route::get('Tasks/delete/{id}/{empid}','TaskController@deleteEmployee')->name('Tasks.deleteEmployee');
Route::get('Tasks/add/{id}/{empid}','TaskController@addEmployee')->name('Tasks.addEmployee');

Route::get('/{id}/myTasks','TaskController@MyTasks')->name('Tasks.MyTasks');
Route::get('/addTask/{id_proj}','TaskController@addTaskToPrj')->name('Tasks.addTaskToPrj');/* ~~ */

Route::resource('Clients','ClientController');
Route::resource('Users','UserController');
Route::get('User/editPassword','UserController@editPassword')->name('User.editPassword');
Route::match(['PUT', 'PATCH'],'User/updatePassword','UserController@updatePassword')->name('User.updatePassword');


Route::get('/Userprofile/{id}','UserController@showProfile')->name('User.Profile');
Route::post('/profile/{userID}','UserController@update_avatar')->name('User.updateAvatar');

Route::get('datatables/{name}', 'HomeController@index2')->name('datatables');
Route::get('datatables/getdata/{name}', 'HomeController@getData')->name('datatables.getdata');

// Route::get('ajaxdata/removedata/{name}', 'HomeController@removedata')->name('datatables.removedata');
Route::get('ajaxdata/massremove/{name}', 'HomeController@massremove')->name('datatables.massremove');
Route::get('calendar','CalendarController@index')->name('calendar.index');
Route::post('calendar','CalendarController@addProject')->name('calendar.addProject');
?>

Livrable/Gestionnaire_de_Projets/app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;//added
use App\Http\Controllers\Controller;
use Session;
use Auth;
use App\User;
use App\Task;
use App\Task_User;
class UserController extends Controller
{

	public function __construct(){
   /*permettre à l'invité de changer son mot de passe */
	 /*autoriser tous les utilisateurs à mettre à jour leur avatar de profil uniquement*/
	 /*seul l'administrateur a accès à la base de données de tous les utilisateurs*/
	 /*seuls le gérant et l'admin peuvent ajouter des utilisateurs .. (Admin ajoute Gérant) */
  	// $this->middleware('admin',['except' => ['show','update_avatar','update','editPassword','updatePassword']]);
      $this->middleware('auth');
	}

	//
	// returns register
	//
	public function registerIndex(){
		return view('auth.register');
	}
	//
	public function update_avatar(Request $request,$id){

		$this->validate($request, [
		 'avatar'  => 'required|mimes:jpg,jpeg,png'
     ]);
			$image =$request->file('avatar');
			$new_image = rand() . '.' . $image->getClientOriginalExtension();
      		$image->move(public_path('storage/avatars'), $new_image);/*put image in storage folder*/

			$user=User::find($id);
			$user->avatar=$new_image;
			$user->save();

		 return back()->with('success', 'Image Uploaded Successfully')->with('user', $user);

		/*
		 $this->validate($request, [
		  'avatar'  => 'required|image|mimes:jpg,png,gif|max:2048'
		]);*/
   }

	/**
		* Display a listing of the resource.
		*
		* @return \Illuminate\Http\Response
		*/
	public function index()
	{
		$this->authorize('index', User::class);
		$us = User::all();
		$u = Auth::user();

		return view('Users.index')->withUsers($us)->withUser($u);
	}

	/**
		* Show the form for creating a new resource.
		*
		* @return \Illuminate\Http\Response
		*/
	public function create()
	{
		 $this->authorize('create', User::class);
		return view('auth.register');
	}
/*storeAdmin(){
	admin role
}*/
	/**
		* Stocker une ressource nouvellement créée dans le stockage.
		*
		* @param  \Illuminate\Http\Request  $request
		* @return \Illuminate\Http\Response
		*/
	public function store(Request $request)
	{
		$u = new User([
			'name' => $request->name,
			'email' => $request->email,
			'password' => bcrypt($request->password),
			'role' => $request->role,
			'comment' => $request->comment,
		]);
		// dd($request->all(),$u);
		$u->save();

		flash('Utilisateur ajouté avec succé !')->success();
		return redirect()->route('Users.index');
	}

	/**
		* Affiche la ressource spécifiée.
		*
		* @param  int  $id
		* @return \Illuminate\Http\Response
		*/
	public function show($id) /*auth profile*/
	{
		$u = User::find($id);

		if($u->role == 'EMPLOYEE')
			$u->hoursCount = User::getEmployeHoursCount($id);

		return view('Users.show')->withUser($u);
	}

	public function showProfile($id) /*users profile*/
	{

		$u = User::find($id);
		$this->authorize('showProfile',$u);

		if($u->role == 'EMPLOYEE')
			$u->hoursCount = User::getEmployeHoursCount($id);



		return view('Users.Profile')->withUser($u);
	}

	/**
		* Afficher le formulaire pour modifier la ressource spécifiée.
		*
		* @param  int  $id
		* @return \Illuminate\Http\Response
		*/
	public function edit($id)
	{

		$u = User::find($id);
		 $this->authorize('edit',$u);

			return view('Users.edit')->withUser($u);
	}
	/*
	 *  formulaire pour modifier le mot de passe
	*/
	public function editPassword()
	{

			return view('Mail.edit_Password');
	}
	/*
	* modifierpassword
	*/
	public function updatePassword(Request $request)
	{

			$u = User::where('email','=',$request->email)->first();
		$u->password = bcrypt($request->password);

		$u->save();

    flash('Mot de passe a été modifié. Veuillez vous connecter !')->success();
	  return	redirect()->route('login');
	}
	/**
		* Met à jour la ressource spécifiée dans le stockage.
		*
		* @param  \Illuminate\Http\Request  $request
		* @param  int  $id
		* @return \Illuminate\Http\Response
		*/
	public function update(Request $request, $id)
	{

			$u = User::find($id);


		$u->name = $request->name;
		$u->email = $request->email;
		$u->role = $request->role;/*attribuer un nouveau role*/
	//	$u->password = $request->password;

		$u->comment = $request->comment;

		$u->save();
    flash('Utilisateur enregistré avec succès !')->success();
		return redirect()->route('User.Profile',$u->id)->withUser($u);
	}

	/**
		*Supprime la ressource spécifiée du stockage.
		*
		* @param  int  $id
		* @return \Illuminate\Http\Response
		*/
	public function destroy($id)
	{

		$u = User::find($id);
		 $this->authorize('delete',$u);

    if($u->role=='EMPLOYEE'){/*détache les tâches de cet utilisateur*/
			$tasks_id=Task_User::where('user_id',$u->id)->get(['task_id']);
			$tasks=Task::whereIn('id',$tasks_id)->get();
			foreach($tasks as $task){

			}
		}
		$u->delete();

		flash('Utilisateur supprimé avec succès !')->warning();
		return redirect()->route('Users.index');
	}
}

Livrable/Gestionnaire_de_Projets/resources/views/Users/Profile.blade.php
@extends('layouts.structure')

@section('jss')
@parent
 <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
 <script>

 $(document).ready(function(){
   function selectedValue(){
     //var val =document.getElementById('role').value;
     alert($('#role'));
   }
 });
 </script>
@endsection
@section('content')

<div class="container">

  <div class="page-header">
    <br>
          <h2 style="color :gray" class="ml-5">Profil de : {{$user->name}}</h2>
  </div><hr>

	<div class="row">
      <!-- left column -->
      <div class="col-md-3">
        <div class="text-center">
          <img src="{{URL::to('/')}}/storage/avatars/{{ $user->avatar }}" style="border-radius:50%;height:50% ;width:50%" class="img-circle" alt="avatar">
          <h6>{{$user->name}}</h6>

        </div>
      </div>

        <!-- modifier la colonne du formulaire -->
    <div class="col-md-9">

              <h3>Informations personnelles</h3><br>
              <form action="{{ route('Users.edit',$user->id) }}" method="get">
              	<button type="submit" class="btn btn-primary float-right"><i class="fa fa-edit"></i> Modifier</button>
              </form>
              <br><hr><br>

              <form class="form-horizontal" role="form">
                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Nom:</label>
                  <div class="col-lg-8" >
                    <input type="text" class="form-control sm-2" name="name" value="{{$user->name}}" disabled>
                  </div>
                </div>

                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Rôle:</label>
                  <div class="col-lg-8" >
                  <input type="text" class="form-control sm-2" value="{{$user->role}}" disabled>
                  </div>
                </div>


                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Email:</label>
                  <div class="col-lg-8">
                    <input type="text" class="form-control sm-2" name="email"  value="{{$user->email}}" disabled>
                  </div>
                </div>

            </form>
      </div>
    </div>
  </div>
      <hr>


@endsection

Livrable/Gestionnaire_de_Projets/resources/views/Users/edit.blade.php
@extends('layouts.structure')

@section('csss')
	@parent
	<link href="{{ asset('fonts/fontawesome-5.1.1/css/all.css') }}" rel="stylesheet">

<style>
.imageStuff:hover{cursor: progress;}
.imageStuff:action{cursor: pointer;}

</style>
@endsection
@section('jss')
@parent
 <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
 <script>

 $(document).ready(function(){
   function selectedValue(){
     //var val =document.getElementById('role').value;
     alert($("#role"));
   }
 });
 </script><script>
 $(document).ready(function(){
    $('#avatar').on('change', function(){
        //  alert($(this).val());
          $('#submit').click();
      });
   });
 </script>
@endsection
@section('content')

<div class="container">

  <div class="page-header">
    <br>
          <h2 style="color :gray" class="ml-5">{{$user->name}}</h2>
  </div><hr>

	<div class="row">

      <!-- colonne de gauche -->
      <div class="col-md-3">
        <div class="text-center">
          <img id="imgclicked" src="{{URL::to('/')}}/storage/avatars/{{ $user->avatar }}" class="imageStuff" style="border-radius:50%;height:50% ;width:50%" alt="avatar" >
          <h6>{{$user->name}}</h6>
        </div>
      </div>

        <!-- modifier la colonne du formulaire -->
    <div class="col-md-9">

              <h3>Informations personnelles</h3><br>



                <form action="{{ route('Users.update', $user) }}" method="POST" class="form-horizontal">
                       <input type="hidden" name="_method" value="PUT">
                       <input type="hidden" name="_token" value="{{ csrf_token() }}">

                <div class="form-group ">
                  <label class="col-lg-3 control-label">Nom :</label>
                  <div class="col-lg-8">
                    <input type="text" class="form-control sm-2 mb-3" name="name" value="{{$user->name}}">
                  </div>
                </div>

                <div class="col-sm"><!-- vu par les utilisateurs -->
                  <div class="form-row form-inline">
                    <div class="form-group mr-4">
                      <label class="col-lg-3 control-label col-4 mr-2">Role :</label>
                        	<input type="text" class="form-control col-8" value="{{$user->role}}" disabled>
                    </div>

                  <div class="col input-group form-inline "> <!-- vu par les supérieurs -->
                    <?php $rolearray = array('ADMIN', 'MANAGER', 'PROJECT_MANAGER', 'EMPLOYEE'); ?>

                      <select class="custom-select col-6" id="old_role"  onchange="$('#role').val($('#old_role').val());">
                          <label class="col-lg-3 control-label col-4 mr-2">Changer Role :</label>
                         @foreach($rolearray as $i=>$value)
                             <option  value="{{$rolearray[$i]}}" {{($rolearray[$i]==$user->role)?'selected':''}} >{{ $rolearray[$i] }}</option>
                         @endforeach
                      </select>
                      <input hidden type="text" name="role"  id="role" value="{{$user->role}}">
                 </div>
               </div>
            </div>

                <div class="form-group mt-3">
                  <label class="col-lg-3 control-label">Email :</label>
                  <div class="col-lg-8">
                    <input type="text" class="form-control" name="email"  value="{{$user->email}}">
                  </div>
                </div>

                <!--  <div class="form-group"> ne doit pas être vu .. change le mot de passe
                  <label class="col-md-3 control-label">Mot de passe:</label>
                  <div class="col-md-8">
                    <input type="text" class="form-control" name="password"  value="{{$user->password}}">
                  </div>
                </div>-->

                <div class="form-group mt-3">
                    <label class="col-md-3 control-label">Commentaire :</label> <!-- vu seulement par les supérieurs -->
                    <div class="col-md-8">
                      <textarea type="text" class="form-control" name="comment" >{{$user->comment}}</textarea>
                    </div>
                  <hr>
                  <div class="col-md-8">
                    <button type="submit" name="submit" class="btn btn-success float-right"> <i class="fas fa-save"> Enregistrer</i></button>
                  </div>
               </div>
        </form>
    </div>
  </div>
</div>
      <hr>
@endsection

Livrable/Gestionnaire_de_Projets/resources/views/Users/index.blade.php
@extends('layouts.structure')

@section('jss')
@parent
<script type="text/javascript" charset="utf8" src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>
<script>
$(document).ready( function () {
	$('#users_table').DataTable({
		language: {
			"decimal":        "",
			"emptyTable":     "Aucune donnée disponible.",
			"info":           "Afficher de _START_ à _END_ de _TOTAL_ entrées",
			"infoEmpty":      "Afficher 0 à 0 de 0 entrées",
			"infoFiltered":   "(filtré à partir des entrées totales _MAX_)",
			"infoPostFix":    "",
			"thousands":      ",",
			"lengthMenu":     "Afficher _MENU_ entrées",
			"loadingRecords": "Chargement...",
			"processing":     "En cours de traitement...",
			"search":         "Chercher:",
			"zeroRecords":    "Aucun enregistrements correspondants trouvés",
			"paginate": {
				"first":      "Premier",
				"last":       "Dernier",
				"next":       "Prochain",
				"previous":   "Précédent"
			},
			"aria": {
				"sortAscending":  ": activer pour trier par ordre croissant",
				"sortDescending": ": activer pour trier par ordre descendant"
			}
		}
	});
} );
</script>
@endsection

@section('csss')
	@parent
	<style> h2{ color: green; } i{padding-top: 10%;}</style>
@endsection

@section('content')

 <div class="page-header">
		<div class="form-group align-center">
			     	 <h2>Liste des utilisateurs</h2>  </div>
</div>
<br><br>
<table class="table table-responsive-lg" id="users_table" data-order='[[ 1, "asc" ]]' data-page-length='5'>
<thead>
	<tr>
		<th scope="col">Nom</th>
		<th scope="col" class="d-none d-lg-block" style="border-bottom:none;">Email</th>
		{{-- <th scope="col">mot de passe</th> --}}
		<th scope="col">Rôle</th>
		<th scope="col" class="d-none d-lg-block" style="border-bottom:none;">Commentaire</th>
		<th scope="col"></th>

	</tr>
</thead>
<tbody>
	@foreach($users as $u)
	<tr>
		<th scope="row">{{$u->name}}</th>
		<td scope="row" class="d-none d-lg-block">{{$u->email}}</th>
		{{-- <td scope="row">{{$u->password}}</th> --}}
		<td scope="row">
			{{
				($u->role=='EMPLOYEE')?'Employé':(($u->role=='MANAGER')?'Gérant':(($u->role=='PROJECT_MANAGER')?'Chef de Projet':'Admin'))
			}}
		</th>
		<td scope="row" class="d-none d-lg-block">{{$u->comment}}</th>
		<td scope="row">
			<form action="{{ route('User.Profile',$u->id) }}" method="get">
				<input hidden type="submit" id="show{{$u->id}}" class="btn btn-primary">
			</form>
			<form action="{{ route('Users.edit',$u->id) }}" method="get">
				<input hidden type="submit" id="edit{{$u->id}}" class="btn btn-primary">
			</form>
			<form action="{{ route('Users.destroy',$u->id) }}" method="post">
				{!! method_field('delete') !!}
				{!! csrf_field() !!}
				<input hidden type="submit" class="btn btn-danger" id="delete{{$u->id}}">
			</form>
			<div class="btn-group" role="group" aria-label="Basic example">
        @if(Auth::user()->Auth_hasRole('ADMIN')||Auth::user()->Auth_hasRole('MANAGER'))
          @if($u->role!='ADMIN')<!--ne pas modifier l'admin -->
				<i class="btn btn-success fa fa-eye text-dark" aria-hidden="true" onclick="$('#show{{$u->id}}').click();"
					{{-- id="voir{{$u->id}}"
					onmouseover="$('#voir{{$u->id}}').val('voir');"
					onmouseout="$('#voir{{$u->id}}').val('v');" --}}
				value="v"></i>
          @endif
        @endif
        <!--can('edit',App\User::class,$u)-->
      	@if(Auth::user()->Auth_hasRole('ADMIN')||Auth::user()->Auth_hasRole('MANAGER'))
          @if($u->role!='ADMIN')<!--ne pas modifier l'admine -->
				  <i class="btn btn-primary fas fa-pencil-alt text-dark" aria-hidden="true" onclick="$('#edit{{$u->id}}').click();" value="m"></i>
          @endif
        @endif
        <!--can('delete',App\User::class,$u)-->
        @if(Auth::user()->Auth_hasRole('ADMIN')||Auth::user()->Auth_hasRole('MANAGER'))
          @if($u->role!='ADMIN')<!--ne pas modifier l'admine -->
				  {{-- <i <i class="btn btn-secondary fas fa-file-archive text-dark" aria-hidden="true" onclick="$('#delete{{$u->id}}').click();" value="s"></i> --}}
          @endif
        @endif
      </div>
		</td>
	</tr>
	@endforeach
</tbody>
</table>
@endsection

Livrable/Gestionnaire_de_Projets/resources/views/Users/show.blade.php
@extends('layouts.structure')

@section('jss')
@parent
 <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
 <script>

 $(document).ready(function(){
   function selectedValue(){
     //var val =document.getElementById('role').value;
     alert($('#role'));
   }
 });
 </script>
@endsection
@section('content')

<div class="container">

  <div class="page-header">
    <br>
          <h2 style="color :gray" class="ml-5">Mon Profil</h2>
          <h6 style="color :seagreen" class="ml-5 pl-5">{{$user->hoursCount}}</h6>
  </div><hr>

	<div class="row">
      <!-- colonne de gauche -->
      <div class="col-md-3">
        <div class="text-center">
          <img id="mypic" src="{{URL('/')}}/storage/avatars/{{ ($user->avatar)?$user->avatar:'default.png' }}"
            style="border-radius:50%;height:50% ;width:50%" class="img-circle" alt="avatar">
          <input id="saveProfile" class="btn btn-success" type="submit" value="Enregistrer" hidden onclick="$('#form').submit();">

          <h6>{{$user->name}}</h6>
           <form action="{{ route('User.updateAvatar',$user->id) }}" method="post" enctype="multipart/form-data" id="form">
             <input  type="file" name="avatar" id="avatar"
              onchange="
              var reader = new FileReader();
              reader.onload = function (e) {
                 $('#mypic').attr('src', e.target.result);
              }
             reader.readAsDataURL(document.getElementById('avatar').files[0]);
              // console.log($(this));
              // $('#mypic').attr('src','{{URL::to('/')}}/storage/avatars/default.png');

              $('#saveProfile').attr('hidden',false);
              " hidden>

             <input  type="button" id="new_avatar"  class="btn btn-primary" value="Changer d'Avatar" onclick="$('#avatar').click();">
             <input  hidden value="{{ csrf_token() }}" name="_token">
           </form>
        </div>
      </div>

        <!-- edit form column -->
    <div class="col-md-9">

              <h3>Informations personnelles</h3><br>

              <form class="form-horizontal" role="form">
                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Nom:</label>
                  <div class="col-lg-8" >
                    <input type="text" class="form-control sm-2" name="name" value="{{$user->name}}" disabled>
                  </div>
                </div>

                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Role:</label>
                  <div class="col-lg-8" >
                  <input type="text" class="form-control sm-2" value="{{$user->role}}" disabled>
                  </div>
                </div>


                <div class="form-group form-inline">
                  <label class="col-lg-3 control-label">Email:</label>
                  <div class="col-lg-8">
                    <input type="text" class="form-control sm-2" name="email"  value="{{$user->email}}" disabled>
                  </div>
                </div>

            </form>
      </div>
    </div>
  </div>
      <hr>

@endsection